package io.fabric8.kubernetes.api.model.storage;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.fabric8.kubernetes.api.builder.Fluent;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.fabric8.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import java.lang.String;
import java.util.function.Predicate;
import java.lang.Integer;
import java.lang.Deprecated;
import java.lang.Long;
import java.util.Iterator;
import java.util.Collection;
import java.lang.Object;
import java.util.List;
import java.lang.Boolean;
import java.util.Map;

 /**
  * Generated
  */
public interface CSIDriverSpecFluent<A extends io.fabric8.kubernetes.api.model.storage.CSIDriverSpecFluent<A>> extends io.fabric8.kubernetes.api.builder.Fluent<A>{
  public java.lang.Boolean getAttachRequired();
  public A withAttachRequired(java.lang.Boolean attachRequired);
  public java.lang.Boolean hasAttachRequired();
  public java.lang.String getFsGroupPolicy();
  public A withFsGroupPolicy(java.lang.String fsGroupPolicy);
  public java.lang.Boolean hasFsGroupPolicy();
  
  /**
   * Method is deprecated. use withFsGroupPolicy instead.
   */
  @java.lang.Deprecated
  public A withNewFsGroupPolicy(java.lang.String arg0);
  public java.lang.Boolean getPodInfoOnMount();
  public A withPodInfoOnMount(java.lang.Boolean podInfoOnMount);
  public java.lang.Boolean hasPodInfoOnMount();
  public java.lang.Boolean getRequiresRepublish();
  public A withRequiresRepublish(java.lang.Boolean requiresRepublish);
  public java.lang.Boolean hasRequiresRepublish();
  public java.lang.Boolean getStorageCapacity();
  public A withStorageCapacity(java.lang.Boolean storageCapacity);
  public java.lang.Boolean hasStorageCapacity();
  public A addToTokenRequests(java.lang.Integer index,io.fabric8.kubernetes.api.model.storage.TokenRequest item);
  public A setToTokenRequests(java.lang.Integer index,io.fabric8.kubernetes.api.model.storage.TokenRequest item);
  public A addToTokenRequests(io.fabric8.kubernetes.api.model.storage.TokenRequest... items);
  public A addAllToTokenRequests(java.util.Collection<io.fabric8.kubernetes.api.model.storage.TokenRequest> items);
  public A removeFromTokenRequests(io.fabric8.kubernetes.api.model.storage.TokenRequest... items);
  public A removeAllFromTokenRequests(java.util.Collection<io.fabric8.kubernetes.api.model.storage.TokenRequest> items);
  public A removeMatchingFromTokenRequests(java.util.function.Predicate<io.fabric8.kubernetes.api.model.storage.TokenRequestBuilder> predicate);
  
  /**
   * This method has been deprecated, please use method buildTokenRequests instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public java.util.List<io.fabric8.kubernetes.api.model.storage.TokenRequest> getTokenRequests();
  public java.util.List<io.fabric8.kubernetes.api.model.storage.TokenRequest> buildTokenRequests();
  public io.fabric8.kubernetes.api.model.storage.TokenRequest buildTokenRequest(java.lang.Integer index);
  public io.fabric8.kubernetes.api.model.storage.TokenRequest buildFirstTokenRequest();
  public io.fabric8.kubernetes.api.model.storage.TokenRequest buildLastTokenRequest();
  public io.fabric8.kubernetes.api.model.storage.TokenRequest buildMatchingTokenRequest(java.util.function.Predicate<io.fabric8.kubernetes.api.model.storage.TokenRequestBuilder> predicate);
  public java.lang.Boolean hasMatchingTokenRequest(java.util.function.Predicate<io.fabric8.kubernetes.api.model.storage.TokenRequestBuilder> predicate);
  public A withTokenRequests(java.util.List<io.fabric8.kubernetes.api.model.storage.TokenRequest> tokenRequests);
  public A withTokenRequests(io.fabric8.kubernetes.api.model.storage.TokenRequest... tokenRequests);
  public java.lang.Boolean hasTokenRequests();
  public A addNewTokenRequest(java.lang.String audience,java.lang.Long expirationSeconds);
  public io.fabric8.kubernetes.api.model.storage.CSIDriverSpecFluent.TokenRequestsNested<A> addNewTokenRequest();
  public io.fabric8.kubernetes.api.model.storage.CSIDriverSpecFluent.TokenRequestsNested<A> addNewTokenRequestLike(io.fabric8.kubernetes.api.model.storage.TokenRequest item);
  public io.fabric8.kubernetes.api.model.storage.CSIDriverSpecFluent.TokenRequestsNested<A> setNewTokenRequestLike(java.lang.Integer index,io.fabric8.kubernetes.api.model.storage.TokenRequest item);
  public io.fabric8.kubernetes.api.model.storage.CSIDriverSpecFluent.TokenRequestsNested<A> editTokenRequest(java.lang.Integer index);
  public io.fabric8.kubernetes.api.model.storage.CSIDriverSpecFluent.TokenRequestsNested<A> editFirstTokenRequest();
  public io.fabric8.kubernetes.api.model.storage.CSIDriverSpecFluent.TokenRequestsNested<A> editLastTokenRequest();
  public io.fabric8.kubernetes.api.model.storage.CSIDriverSpecFluent.TokenRequestsNested<A> editMatchingTokenRequest(java.util.function.Predicate<io.fabric8.kubernetes.api.model.storage.TokenRequestBuilder> predicate);
  public A addToVolumeLifecycleModes(java.lang.Integer index,java.lang.String item);
  public A setToVolumeLifecycleModes(java.lang.Integer index,java.lang.String item);
  public A addToVolumeLifecycleModes(java.lang.String... items);
  public A addAllToVolumeLifecycleModes(java.util.Collection<java.lang.String> items);
  public A removeFromVolumeLifecycleModes(java.lang.String... items);
  public A removeAllFromVolumeLifecycleModes(java.util.Collection<java.lang.String> items);
  public java.util.List<java.lang.String> getVolumeLifecycleModes();
  public java.lang.String getVolumeLifecycleMode(java.lang.Integer index);
  public java.lang.String getFirstVolumeLifecycleMode();
  public java.lang.String getLastVolumeLifecycleMode();
  public java.lang.String getMatchingVolumeLifecycleMode(java.util.function.Predicate<java.lang.String> predicate);
  public java.lang.Boolean hasMatchingVolumeLifecycleMode(java.util.function.Predicate<java.lang.String> predicate);
  public A withVolumeLifecycleModes(java.util.List<java.lang.String> volumeLifecycleModes);
  public A withVolumeLifecycleModes(java.lang.String... volumeLifecycleModes);
  public java.lang.Boolean hasVolumeLifecycleModes();
  public A addNewVolumeLifecycleMode(java.lang.String arg0);
  public interface TokenRequestsNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.storage.TokenRequestFluent<io.fabric8.kubernetes.api.model.storage.CSIDriverSpecFluent.TokenRequestsNested<N>>{
    public N and();
    public N endTokenRequest();
    
  }
  
}