package io.fabric8.kubernetes.api.model.storage;

import io.fabric8.kubernetes.api.model.ObjectMeta;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.fabric8.kubernetes.api.model.TopologySelectorTerm;
import io.fabric8.kubernetes.api.builder.Fluent;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.fabric8.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import java.lang.String;
import io.fabric8.kubernetes.api.model.ObjectMetaBuilder;
import java.util.LinkedHashMap;
import java.util.function.Predicate;
import java.lang.Integer;
import io.fabric8.kubernetes.api.model.ObjectMetaFluent;
import java.lang.Deprecated;
import java.util.Collection;
import java.lang.Object;
import java.util.List;
import java.lang.Boolean;
import java.util.Map;

 /**
  * Generated
  */
public interface StorageClassFluent<A extends io.fabric8.kubernetes.api.model.storage.StorageClassFluent<A>> extends io.fabric8.kubernetes.api.builder.Fluent<A>{
  public java.lang.Boolean getAllowVolumeExpansion();
  public A withAllowVolumeExpansion(java.lang.Boolean allowVolumeExpansion);
  public java.lang.Boolean hasAllowVolumeExpansion();
  public A addToAllowedTopologies(java.lang.Integer index,io.fabric8.kubernetes.api.model.TopologySelectorTerm item);
  public A setToAllowedTopologies(java.lang.Integer index,io.fabric8.kubernetes.api.model.TopologySelectorTerm item);
  public A addToAllowedTopologies(io.fabric8.kubernetes.api.model.TopologySelectorTerm... items);
  public A addAllToAllowedTopologies(java.util.Collection<io.fabric8.kubernetes.api.model.TopologySelectorTerm> items);
  public A removeFromAllowedTopologies(io.fabric8.kubernetes.api.model.TopologySelectorTerm... items);
  public A removeAllFromAllowedTopologies(java.util.Collection<io.fabric8.kubernetes.api.model.TopologySelectorTerm> items);
  public java.util.List<io.fabric8.kubernetes.api.model.TopologySelectorTerm> getAllowedTopologies();
  public io.fabric8.kubernetes.api.model.TopologySelectorTerm getAllowedTopology(java.lang.Integer index);
  public io.fabric8.kubernetes.api.model.TopologySelectorTerm getFirstAllowedTopology();
  public io.fabric8.kubernetes.api.model.TopologySelectorTerm getLastAllowedTopology();
  public io.fabric8.kubernetes.api.model.TopologySelectorTerm getMatchingAllowedTopology(java.util.function.Predicate<io.fabric8.kubernetes.api.model.TopologySelectorTerm> predicate);
  public java.lang.Boolean hasMatchingAllowedTopology(java.util.function.Predicate<io.fabric8.kubernetes.api.model.TopologySelectorTerm> predicate);
  public A withAllowedTopologies(java.util.List<io.fabric8.kubernetes.api.model.TopologySelectorTerm> allowedTopologies);
  public A withAllowedTopologies(io.fabric8.kubernetes.api.model.TopologySelectorTerm... allowedTopologies);
  public java.lang.Boolean hasAllowedTopologies();
  public java.lang.String getApiVersion();
  public A withApiVersion(java.lang.String apiVersion);
  public java.lang.Boolean hasApiVersion();
  
  /**
   * Method is deprecated. use withApiVersion instead.
   */
  @java.lang.Deprecated
  public A withNewApiVersion(java.lang.String arg0);
  public java.lang.String getKind();
  public A withKind(java.lang.String kind);
  public java.lang.Boolean hasKind();
  
  /**
   * Method is deprecated. use withKind instead.
   */
  @java.lang.Deprecated
  public A withNewKind(java.lang.String arg0);
  
  /**
   * This method has been deprecated, please use method buildMetadata instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.ObjectMeta getMetadata();
  public io.fabric8.kubernetes.api.model.ObjectMeta buildMetadata();
  public A withMetadata(io.fabric8.kubernetes.api.model.ObjectMeta metadata);
  public java.lang.Boolean hasMetadata();
  public io.fabric8.kubernetes.api.model.storage.StorageClassFluent.MetadataNested<A> withNewMetadata();
  public io.fabric8.kubernetes.api.model.storage.StorageClassFluent.MetadataNested<A> withNewMetadataLike(io.fabric8.kubernetes.api.model.ObjectMeta item);
  public io.fabric8.kubernetes.api.model.storage.StorageClassFluent.MetadataNested<A> editMetadata();
  public io.fabric8.kubernetes.api.model.storage.StorageClassFluent.MetadataNested<A> editOrNewMetadata();
  public io.fabric8.kubernetes.api.model.storage.StorageClassFluent.MetadataNested<A> editOrNewMetadataLike(io.fabric8.kubernetes.api.model.ObjectMeta item);
  public A addToMountOptions(java.lang.Integer index,java.lang.String item);
  public A setToMountOptions(java.lang.Integer index,java.lang.String item);
  public A addToMountOptions(java.lang.String... items);
  public A addAllToMountOptions(java.util.Collection<java.lang.String> items);
  public A removeFromMountOptions(java.lang.String... items);
  public A removeAllFromMountOptions(java.util.Collection<java.lang.String> items);
  public java.util.List<java.lang.String> getMountOptions();
  public java.lang.String getMountOption(java.lang.Integer index);
  public java.lang.String getFirstMountOption();
  public java.lang.String getLastMountOption();
  public java.lang.String getMatchingMountOption(java.util.function.Predicate<java.lang.String> predicate);
  public java.lang.Boolean hasMatchingMountOption(java.util.function.Predicate<java.lang.String> predicate);
  public A withMountOptions(java.util.List<java.lang.String> mountOptions);
  public A withMountOptions(java.lang.String... mountOptions);
  public java.lang.Boolean hasMountOptions();
  public A addNewMountOption(java.lang.String arg0);
  public A addToParameters(java.lang.String key,java.lang.String value);
  public A addToParameters(java.util.Map<java.lang.String,java.lang.String> map);
  public A removeFromParameters(java.lang.String key);
  public A removeFromParameters(java.util.Map<java.lang.String,java.lang.String> map);
  public java.util.Map<java.lang.String,java.lang.String> getParameters();
  public <K,V>A withParameters(java.util.Map<java.lang.String,java.lang.String> parameters);
  public java.lang.Boolean hasParameters();
  public java.lang.String getProvisioner();
  public A withProvisioner(java.lang.String provisioner);
  public java.lang.Boolean hasProvisioner();
  
  /**
   * Method is deprecated. use withProvisioner instead.
   */
  @java.lang.Deprecated
  public A withNewProvisioner(java.lang.String arg0);
  public java.lang.String getReclaimPolicy();
  public A withReclaimPolicy(java.lang.String reclaimPolicy);
  public java.lang.Boolean hasReclaimPolicy();
  
  /**
   * Method is deprecated. use withReclaimPolicy instead.
   */
  @java.lang.Deprecated
  public A withNewReclaimPolicy(java.lang.String arg0);
  public java.lang.String getVolumeBindingMode();
  public A withVolumeBindingMode(java.lang.String volumeBindingMode);
  public java.lang.Boolean hasVolumeBindingMode();
  
  /**
   * Method is deprecated. use withVolumeBindingMode instead.
   */
  @java.lang.Deprecated
  public A withNewVolumeBindingMode(java.lang.String arg0);
  public interface MetadataNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.ObjectMetaFluent<io.fabric8.kubernetes.api.model.storage.StorageClassFluent.MetadataNested<N>>{
    public N and();
    public N endMetadata();
    
  }
  
}